Description

For constants, it is difficult to get the source location where it was (last) defined. I request either of the following to be implemented:

Tracepoint emits a signal when a constant is defined.

Implement a Constant class (similar to Method class) and a constant method (similar to method method) that behave as follows:

  foo1.rb

  1| module Foo

  2|   Bar = :bar

  3| end

  4| Foo.constant(:Bar) #=> #<Constant: Foo#Bar>

  5| Foo.constant(:Bar).source_location #=> ["foo1.rb", 2]

Implement Module#constant_source_location

  foo2.rb

  1| module Foo

  2|   Bar = :bar

  3| end

  4| Foo.constant_source_location(:Bar) #=> ["foo2.rb", 2]
History

#1 - 01/27/2015 11:04 AM - ko1 (Koichi Sasada)
- Assignee set to matz (Yukihiro Matsumoto)

Matz issue.

#2 - 06/25/2017 09:08 AM - jphelps (Jeremy Phelps)

I've got a patch ready for this, but I have no idea how to submit it. There are serious contradictions in this page:

https://bugs.ruby-lang.org/projects/ruby/wiki/HowToContribute

It says that the changes should be against "the trunk of Ruby", and that "only Ruby 2.4 may accept new features." But the trunk on GitHub is Ruby

2.5.

It says that the patch should be a unified diff, but it also says different changes should not be mixed in a single commit. But diff files don't have

commits; only pull requests and whole repos do. But it says that you only accept PRs for "tiny fixes", and only if they don't require discussion.

#3 - 06/25/2017 10:08 AM - normalperson (Eric Wong)

jeremy.phelps@instacart.com wrote:

I've got a patch ready for this, but I have no idea how to

submit it. There are serious contradictions in this page:

https://bugs.ruby-lang.org/projects/ruby/wiki/HowToContribute

It says that the changes should be against "the trunk of

Ruby", and that "only Ruby 2.4 may accept new features." But

the trunk on GitHub is Ruby 2.5.

 Make the change against trunk, any mentions of specific version

numbers is probably outdated.  Maybe you have permissions to edit

that page?  (I can't stand 

inputs in web browsers and

reply to redmine via email) 

It says that the patch should be a unified diff, but it also

says different changes should not be mixed in a single commit.

But diff files don't have commits; only pull requests and

whole repos do. But it says that you only accept PRs for "tiny

fixes", and only if they don't require discussion.

 The output of "git format-patch" is a superset of unified diff,

you should use that to generate diffs if using git.  "git am"

can be used to apply that output and preserve authorship info

and the commit message.

You can also publish your work to any publically accessible git

repository tell us about how to pull it, here.  The

"git request-pull" command can generate the message text for you.

#4 - 06/26/2017 01:34 AM - jphelps (Jeremy Phelps)

- File const_source_location.tar.gz added

Ok, then here's my patch. I called the method "const_source_location" instead of "constant_source_location", because it uses a lot of the same code

as "const_get".

I don't have access to edit the wiki page.

#5 - 06/26/2017 02:51 AM - normalperson (Eric Wong)

jeremy.phelps@instacart.com wrote:

Ok, then here's my patch. I called the method

"const_source_location" instead of "constant_source_location",

because it uses a lot of the same code as "const_get".

 Thanks. The code looks fine.

I'd suggest rb_ary_new_from_args to avoid the temporary array

(instead of rb_ary_new4) but we can fix it at commit time.
It's up to matz now to approve/deny the feature itself.

Thanks again

#6 - 06/26/2017 03:59 AM - duerst (Martin Dürst)

jphelps (Jeremy Phelps) wrote:

I've got a patch ready for this, but I have no idea how to submit it. There are serious contradictions in this page:

https://bugs.ruby-lang.org/projects/ruby/wiki/HowToContribute

 I updated this page a bit, hopefully removing the contradictions. Please tell us if there still are some problems.

#7 - 11/28/2018 01:13 PM - shevegen (Robert A. Heiler)

janfri suggested this issue for the next upcoming developer meeting

at December 2018 so I think it will be approved or rejected then.

I did not yet comment on it so I will comment on it briefly.

I think the functionality would be nice to have; introspection

is very useful, IMO.

Not sure how matz feels about the API suggested but the functionality

may be ok?

#8 - 11/29/2018 12:26 AM - sawa (Tsuyoshi Sawada)

I am glad that this issue is going to be discussed in the next developer meeting, but now that we have a way to know not only the file name and the

line number but also the column number/position as well for method definitions, I request that this be done for constants as well.

#9 - 12/12/2018 06:59 AM - matz (Yukihiro Matsumoto)

We picked constant_source_location. We will experiment with this method in 2.7 development.

Matz.

#10 - 06/22/2019 04:47 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset git|93843830198ba436e2ea21a60a11758d47cf521b.
const_source_location.tar.gz 1.96 KB 06/26/2017 jphelps (Jeremy Phelps)
